/*===========================================================================*/
/*
 * This file is part of
 * libalinga - a C++ library for Alligned Linguistic Annotation
 *
 * Copyright (C) 2007, 2008 Elaine Tsiang YueLien
 *
 * libalinga is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, see http://www.gnu.org/licenses, or write to the
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
/** @file ManifoldImpl.H                                                     *
 *                                                                           *
 *  ALingA::Manifold implementation interface                                *
 *                                                                           */
/*===========================================================================*/
#ifndef	ManifoldImplementationInterface
#define	ManifoldImplementationInterface

#ifdef __GNUG__
#pragma interface
#endif

#include <ALingA/Manifold.H>


namespace ALingA
{
  class ManifoldImpl
  {
    friend class	Manifold;

  private:
    void *		intf_;

    size_t		perTime_;
    size_t		perSpace_;
    Glib::ustring	timeUnit_;
    Glib::ustring	spaceUnit_;
    Position		timeBias_;
    Position		spaceBias_;
    size_t		gransPerFrame_;
    Glib::ustring	timeOrigin_;
    

    ManifoldImpl(
		 const size_t		perTime
		 ,const size_t		perSpace
		 ,const Glib::ustring	timeUnit
		 ,const Glib::ustring	spaceUnit
		 ,const Position	timeBias
		 ,const Position	spaceBias
		 ,const size_t		gransPerFrame
		 ,const Glib::ustring	timeOrigin
		 );

    ManifoldImpl(
		 const Attribute&
		 );

    ManifoldImpl(
		 ManifoldImpl &
		 );

    ~ManifoldImpl()
    {}

  };

}

#endif

