/*===========================================================================*/
/*
 * This file is part of
 * libalinga - a C++ library for Alligned Linguistic Annotation
 *
 * Copyright (C) 2007, 2008 Elaine Tsiang YueLien
 *
 * libalinga is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, see http://www.gnu.org/licenses, or write to the
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
/** @file XMLwriterImpl.H                                                     *
 *                                                                           *
 *  ALingA::XMLwriter implementation interface                                *
 *                                                                           */
/*===========================================================================*/
#ifndef	XMLwriterImplementationInterface
#define	XMLwriterImplementationInterface

#ifdef __GNUG__
#pragma interface
#endif

#include <ALingA/XMLwriter.H>
#include <stack>


namespace	ALingA
{
  class XMLwriterImpl
  {
    friend class		XMLwriter;

  private:
    XMLwriter *				intf_;

    UShortAttribute			dtdMajor_;
    UShortAttribute			dtdMinor_;
    Glib::ustring			elementName_;
    Glib::ustring &			utext_;
    std::stack<XMLwriterImpl *> *	context_;
    bool				isInstruction_;
    bool				tagCompleted_;
    

    XMLwriterImpl(
		  Glib::ustring		rootName
		  ,unsigned short	dtdMajor
		  ,unsigned short	dtdMinor
		  );

    XMLwriterImpl(
		  XMLwriterImpl &	parent
		  ,Glib::ustring	elementName
		  ,bool			isInstruction = false
		  );

    ~XMLwriterImpl();

  };
}
#endif



